#include "stdaza.h"
#include "input.h"

#include "land.h"

int WINAPI WinMain(	HINSTANCE	hInstance, 
			HINSTANCE	hPrevInstance, 
			LPSTR		lpCmdLine, 
			int			nCmdShow)
{
	HWND		hWnd;
	srand(time(NULL));
	glColor4f(1,1,1,1);

	if (!createWindowsApp(hInstance,hPrevInstance,lpCmdLine,nCmdShow,&hWnd)) closeWindow();

	


	//---

	Landscape* land = new Landscape(64,6);
	land->generate();

	glClearColor(0,0,0,0);
	
	glEnable(GL_COLOR_MATERIAL);

	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	gluPerspective(60, (float)640 / (float)480, 1, 1000);
	
	glEnable(GL_DEPTH_TEST);
	glDepthFunc(GL_LEQUAL);
	
	double angle = 0;

	int active = 1;
	while (active)
	{
		glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

		glMatrixMode(GL_MODELVIEW);
		glLoadIdentity();	
		gluLookAt( 15*cos(angle) + 32, 15*sin(angle) + 32, land->vert(32,32)->height+15,   32, 32, land->vert(32,32)->height,   0, 0, 1);
	
		angle += 0.05;
		
		land->updateViewMatricies();

		
		land->drawPlainSolid();
		/*
		glTranslatef(128,0,0);
		land->drawPlainSolid();
		glTranslatef(-256,0,0);
		land->drawPlainSolid();
		glTranslatef(128,128,0);
		land->drawPlainSolid();
		glTranslatef(0,-256,0);
		land->drawPlainSolid();
		*/
		//land->drawLand();

		glColor3f(1,0,0);
		//land->drawMesh();

		//glBegin(GL_LINES);

		//	glVertex3f(0,0,-20);
		//	glVertex3f(0,0,20);

		//glEnd();

		/*
		glColor3f(0,0,1);
		glBegin(GL_QUADS);
	
			glVertex3f(-50,-50,8);
			glVertex3f(178,-50,8);
			glVertex3f(178,178,8);
			glVertex3f(-50,178,8);

		glEnd();
		*/

		Sleep(5);
		swapBuffers();

		//updateDI();

		//if (keyDown(DIK_Q)) active = 0;

		MSG msg;
		if (GetMessage(&msg, NULL, 0, 0))
		{
		
        TranslateMessage(&msg);
        DispatchMessage(&msg);
		}
		
      
		
	}

	delete land;

	
	//---

	closeWindow();

	return 0;
}
